export default {
  data() {
    return {
      options: {
        annotation: {
          drawTime: "afterDraw",
          events: ["mouseleave", "mouseenter"],
          annotations: []
        }
      }
    };
  },
  created() {
    if (this.spec.lineVertical) {
      this.options.annotation.annotations = this.spec.lineVertical.map(
        (element, index) => this.annotation(element, index)
      );
    }
  },
  methods: {
    annotation(options, index) {
      const { text, x } = options;

      return {
        type: "line",
        mode: "vertical",
        scaleID: "x-axis-0",
        value: new Date(x).getTime(),
        borderColor: "rgba(0,0,255,0.3)",
        borderWidth: 3,
        borderDash: [5, 10],
        label: {
          content: text,
          enabled: true,
          position: "top",
          backgroundColor: "rgba(0,0,0,0.3)"
        },
        onMouseenter: function(e) {
          Object.assign(
            this.chartInstance.options.annotation.annotations[index],
            { borderColor: "rgba(0,0,255,0.8)" },
            {
              label: {
                content: text,
                enabled: true,
                position: "top",
                backgroundColor: "rgba(0,0,0,0.8)"
              }
            }
          );

          this.chartInstance.update();
        },
        onMouseleave: function(e) {
          Object.assign(
            this.chartInstance.options.annotation.annotations[index],
            { borderColor: "rgba(0,0,255,0.3)" },
            {
              label: {
                content: text,
                enabled: true,
                position: "top",
                backgroundColor: "rgba(0,0,0,0.3)"
              }
            }
          );

          this.chartInstance.update();
        }
      };
    }
  }
};
