export default {
  data: function () {
    return {
      exportable: false,
      exportLabel: 'CSV',
      exportFile: 'output',
    }
  },
  methods: {
    initCsvExport() {
      let exportName = 'output'
      const vm = this
      Utils.type.ifObject(this.spec.export, obj => {
        vm.exportable = true
        
        Utils.type.ifString(obj.label, val => {
          vm.exportLabel = val
        })
        Utils.type.ifString(obj.fileName, val => {
          exportName = val
        })
      })
      
      this.exportFile = `${exportName}.csv`
    },
    exportCsv(section) {
      return 'data:text/csv;charset=' + document.characterSet + ',' + encodeURI(this._compileCsvRows(section));
    },
    _compileCsvRows(section) {
      const lines = []
      lines.push(this._compileCsvRow(section.header))
      for (const row of section.rows) {
        lines.push(this._compileCsvRow(row))
      }
      return lines.join("\n")
    },
    _compileCsvRow(row) {
      return row.cellViews.map(view => this._escapeForCsv(view.text)).join(",")
    },
    _escapeForCsv(text) {
      if (Utils.type.isString(text)) {
        if (text === "") {
          return '""'
        } else if (text.contains('"') || text.contains("\n") || text.contains("\r") || text.contains(",")) {
          return '"' + text.replace(/"/g, '""') + '"'
        }
        return text
      }
      return '""'
    },
  }
}
