import { createConsumer } from "@rails/actioncable";

const consumer = createConsumer();

export default {
  data: function() {
    return {
      _wsSocket: null
    };
  },
  methods: {
    $wsInitActionCable(spec) {
      const component = this;
      Utils.type.ifObject(
        spec,
        ws => {
          const channelName = ws.channel;
          const subscription = Object.assign({}, ws.params, {
            channel: channelName
          });

          console.log("Connecting to channel", subscription);

          consumer.subscriptions.create(subscription, {
            connected() {
              const ws = window.vueApp.actionCable;
              ws.channels[channelName] = this;
              console.log("Connected to channel", channelName);
            },

            disconnected() {},

            received(data) {
              const action = data.action;
              const payload = { ...action, filterKey: ws.filterKey };
              if (ws.filterKey === data.filterKey) {
                GLib.action.execute(payload, null, component);
              }
            }
          });
        },
        () => {
          // this._wsDisconnectSocket();
        }
      );
    }
  }
};
