export default class {
  // Execution flows:
  // Button -> Button.onClick() -> Utils.http.execute() -- doesn't save autofill values
  // Button -> Button.onClick() -> form.submit() -- doesn't execute Form.onSubmit(), so cannot call Utils.http.execute() there
  // Submit -> Form.onSubmit() -> Utils.http.execute() -- save autofill values, but cannot have submit action nested in another action
  // TOTRY: Button -> Button.onClick() -> form.clickSubmit() -> submit.click() -> Form.onSubmit() -> Utils.http.execute()
  static submitData(form, component) {
    // const form = target.closest("form");
    // const form = this.formElement;

    // Analogous to Rails' form_with's local
    if (form.dataset.local) {
      form.submit();
    } else {
      const url = form.getAttribute("action");
      const formData = new FormData(form);
      const method = form.getAttribute("method");
      if (method.toUpperCase() === "GET") {
        const data = {
          url: Utils.url.appendParams(url, formData)
        };
        Utils.http.load(data, null, component);
      } else {
        const data = {
          url: url,
          formData: formData
        };
        Utils.http.execute(data, method, component, response => {
          GLib.action.handleResponse(response, component);
        });
      }
    }
  }
}
