export default class Hash {
  constructor(object) {
    for (const key in object) {
      this[key] = object[key];
    }
  }

  remove(key) {
    const value = this[key];
    delete this[key];
    return value;
  }

  without(...keys) {
    for (const key of keys) {
      this.remove(key);
    }
    return this;
  }

  with(...keys) {
    for (const key in this) {
      if (!keys.includes(key)) {
        this.remove(key);
      }
    }
    return this;
  }
}
