export default class {
  static handleResponse(payload, component) {
    if (!Utils.type.isObject(payload)) {
      return;
    }

    const ws = window.vueApp.webSocket;
    Utils.type.ifObject(payload.wsHeader, header => {
      Object.assign(ws.header, header);
      console.log("New header: ", ws.header);
    });

    const actionName = payload.action;
    if (actionName.startsWith("component/")) {
      const methodName = actionName.replace(/^component\//, "");
      console.log(`Executing component action: ${methodName}`);
      component[`action_${methodName}`](payload);
    } else {
      GLib.action.execute(payload, null, component);
    }
  }
}
